// binhexView.cpp : 
//

#include "stdafx.h"
#include "binhex.h"

#include "binhexDoc.h"
#include "binhexView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

unsigned char text[]={"The language to be used can be specified in several different ways. There is no generally accepted standard for this and the user always expects the program understand what s/he means. E.g., to select the German translation one could write de, german, or deutsch and the program should always react the same.Sometimes the specification of the user is too detailed. If s/he, e.g., specifies de_DE.ISO-8859-1 which means German, spoken in Germany, coded using the ISO 8859-1 character set there is the possibility that a message catalog matching this exactly is not available. But there could be a catalog matching de and if the character set used on the machine is always ISO 8859-1 there is no reason why this later message catalog should not be used. (We call this message inheritance.) If a catalog for a wanted language is not available it is not always the second best choice to fall back on the language of the developer and simply not translate any message. Instead a user might be better able to read the messages in another language and so the user of the program should be able to define an precedence order of languages"};
CString strBin,str2,strx;
int anz;
int ii;
int Kvalue=1;
int iFlag;
int first;
int index;
unsigned char zahl[10];
unsigned char CHK,CRC;
unsigned char chx1;
#define ddx  1390

/////////////////////////////////////////////////////////////////////////////
// CBinhexView

IMPLEMENT_DYNCREATE(CBinhexView, CScrollView)

BEGIN_MESSAGE_MAP(CBinhexView, CScrollView)
	//{{AFX_MSG_MAP(CBinhexView)
	ON_COMMAND(IDB_PLUS, OnPlus)
	ON_COMMAND(IDB_MINUS, OnMinus)
	ON_COMMAND(IDB_FLAG, OnFlag)
	ON_UPDATE_COMMAND_UI(IDB_FLAG, OnUpdateFlag)
	//}}AFX_MSG_MAP
	// Standard
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinhexView Konstruktion/Destruktion

CBinhexView::CBinhexView()
{
}

CBinhexView::~CBinhexView()
{
}

BOOL CBinhexView::PreCreateWindow(CREATESTRUCT& cs)
{

	cs.style |= WS_VSCROLL;
	return CScrollView::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CBinhexView Print

BOOL CBinhexView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CBinhexView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{

}

void CBinhexView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	Kvalue++;
	Invalidate();
}

/////////////////////////////////////////////////////////////////////////////
// CBinhexView Diagnose

#ifdef _DEBUG
void CBinhexView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CBinhexView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CBinhexDoc* CBinhexView::GetDocument() 
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBinhexDoc)));
	return (CBinhexDoc*)m_pDocument;
}
#endif //_DEBUG


void CBinhexView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	pDC->SelectObject(&m_font);	
	pDC->SetMapMode( MM_TWIPS );

	CScrollView::OnPrepareDC(pDC, pInfo);
}





void CBinhexView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	memset(&logfontx, 0, sizeof(logfontx));
	logfontx.lfHeight= 6*18;
	logfontx.lfWidth = 5*18;
	logfontx.lfWeight= FW_BOLD;
	CString szFontx;
	szFontx.LoadString(IDS_FONT_NAME1);           // TrueType font

	lstrcpy(logfontx.lfFaceName, szFontx);
	VERIFY(m_fontx.CreateFontIndirect(&logfontx));
	SetFont( &m_fontx);	

	memset(&logfont, 0, sizeof(logfont));
	logfont.lfHeight= 6*32;
	logfont.lfWidth = 5*32;
	logfont.lfWeight= FW_BOLD;
	CString szFont;
	szFont.LoadString(IDS_FONT_NAME1);           // TrueType font

	lstrcpy(logfont.lfFaceName, szFont);
	VERIFY(m_font.CreateFontIndirect(&logfont));
	SetFont( &m_font );	

	memset(&logfont1, 0, sizeof(logfont1));
	logfont1.lfHeight= 6*42;
	logfont1.lfWidth = 5*42;
	logfont1.lfWeight= FW_BOLD;
	CString szFont1;
	szFont1.LoadString(IDS_FONT_NAME1);           // TrueType font

	lstrcpy(logfont1.lfFaceName, szFont1);
	VERIFY(m_font1.CreateFontIndirect(&logfont1));
	SetFont( &m_font1);	


	CSize sizeTotal;
	// ZU ERLEDIGEN: Gesamte Gre dieser Ansicht berechnen
	sizeTotal.cx = 2000; 
	sizeTotal.cy = 20000;
	SetScrollSizes(MM_TWIPS, sizeTotal);

}

void CBinhexView::Binaer(unsigned char chx)
{
int mask;
int xx;

strBin.Format("00000000"); 	mask=0x80;
xx=0; while(xx < 8) {if(chx & mask) strBin.SetAt(xx,'1'); xx++; mask /=2; } 
}


void CBinhexView::Binaer2(unsigned char chx)
{
int mask;
int xx;

strBin.Format("0 0 0 0 0 0 0 0"); 	mask=0x80;
xx=0; while(xx < 8) {if(chx & mask) strBin.SetAt(xx*2,'1'); xx++; mask /=2; } 
}

void CBinhexView::OnPlus() 
{
Kvalue++;
Invalidate();
	
}

void CBinhexView::OnMinus() 
{
if(Kvalue > 1) Kvalue--;
Invalidate();
	
}

void CBinhexView::OnFlag() 
{
	
	if(iFlag==0) iFlag=1; else iFlag=0;
	Invalidate();
    
}

void CBinhexView::OnUpdateFlag(CCmdUI* pCmdUI) 
{
	if(iFlag) pCmdUI->SetCheck(1);
	 else pCmdUI->SetCheck(0);

}


//**********************************************************************************
/////////////////////////////////////////////////////////////////////////////
// CBinhexView Zeichnen

void CBinhexView::OnDraw(CDC* pDC)
{
	CBinhexDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// ZU ERLEDIGEN: Hier Code zum Zeichnen der ursprnglichen Daten hinzufgen

	pDC->SetMapMode( MM_TWIPS );

#define ymin -200 
#define ymax -15900
#define xmin  200	
#define xmax  11300	

#define xx0 420
#define xx1 5800

#define yy0 -800
#define yy1 -4500
#define yy2 -10500

#define ddy 500
#define ddy2 800

	pDC->MoveTo(xmin,ymin);
	pDC->LineTo(xmax,ymin);
	pDC->LineTo(xmax,ymax);
	pDC->LineTo(xmin,ymax);
	pDC->LineTo(xmin,ymin);

	pDC->SelectObject(&m_fontx);	
	pDC->TextOut(xmin+50,ymax + 100,"Orgler electronic 04/05 OL Bit operations");


	int yy,xx;

	CString str1,str;

	pDC->SelectObject(&m_font1);	
	str1.Format("Kvalue = %d",Kvalue);
	pDC->TextOut(xx0,ymin - 50,str1);

//**************************************************************************

	yy = yy0;
	xx = xx0;
	first =1;

	index= (Kvalue-1) * 48;
	pDC->SelectObject(&m_font1);	
	pDC->TextOut(xx,yy,"1) the bits are shift left");	yy -= ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = chx1 << 1;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);


			if(iFlag || first) 
			{	
				first = 0;
				Binaer(chx1);				// modified value
				chx1 = chx1 >> 1;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);				// original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);

			}
      xx += ddx;
  	}

	yy -= ddy2*2;

   	
//**************************************************************
    xx = xx0;
	first =1;

	pDC->SelectObject(&m_font1);
	pDC->TextOut(xx,yy,"2) Nibbles are swapped");	yy -= ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = (chx1 * 16) + chx1 /16;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);

			if(iFlag || first) 
			{	
				first = 0;
				chx1 = (chx1 * 16) + chx1 /16;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);    // original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);
			}
      xx += ddx;
  	}

	yy -= ddy2*2;
//*********************************************************************
    xx = xx0;
	first =1;
	pDC->SelectObject(&m_font1);	
	pDC->TextOut(xx,yy,"3) Bits changed: 0 with 1 and 1 with 0");	yy-=ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = chx1 ^ 0xFF;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);

			if(iFlag || first) 
			{	
			first = 0;
			Binaer(chx1);     // modified value
				chx1 = chx1 ^ 0xFF;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);    // original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);
			}
      xx += ddx;
  	}

	yy -= ddy2*2;
//*********************************************************************
    xx = xx0;
	first =1;
	pDC->SelectObject(&m_font1);	
	pDC->TextOut(xx,yy,"4) Bytevalue negated");	yy-=ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = chx1 * -1;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);

			if(iFlag || first) 
			{	
				first = 0;
				Binaer(chx1);     // modified value
				chx1 = chx1 * -1;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);    // original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);
			}
      xx += ddx;
  	}

	yy -= ddy2*2;

//*********************************************************************
    xx = xx0;
	first =1;
	pDC->SelectObject(&m_font1);	
	pDC->TextOut(xx,yy,"5) a constant value is added");	yy-=ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = chx1 + 150;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);


		if(iFlag || first) 
			{	
				first = 0;
				Binaer(chx1);     // modified value
				chx1 = chx1 - 150;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);    // original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);
			}
      xx += ddx;
  	}

	yy -= ddy2*2;
//*********************************************************************
    xx = xx0;
	first =1;
	pDC->SelectObject(&m_font1);	
	pDC->TextOut(xx,yy,"6) a constant value is subtracted");	yy-=ddy2;

	ii = 8;
	while(ii--) 
	{
        chx1 = text[index++];
		chx1 = chx1 - 97 ;

		str1.Format("%02X",chx1);
		pDC->SelectObject(&m_font1);	
		pDC->TextOut(xx,yy,str1);

			if(iFlag || first) 
			{	
				first = 0;
				Binaer(chx1);     // modified value
				chx1 = chx1 + 97;
				str2 = chx1;
					pDC->SelectObject(&m_font);	
				pDC->TextOut(xx,yy + ddy/2,str2);
				str2.Format("%02X",chx1);
				pDC->TextOut(xx,yy - ddy/2,str2);
				pDC->TextOut(xx,yy - ddy,strBin);
				Binaer(chx1);    // original value
				pDC->TextOut(xx,yy - ddy-ddy/2,strBin);
			}
      xx += ddx;
  	}
	yy -= ddy2*2;
}
